%%%%%%                 %%%%%%
% PERSONALITY,              %   
%    CREDIT CONSTRAINTS     %
%       AND SELF-EMPLOYMENT % 
%%%%%%                %%%%%%%

global  id ...
		se_04 pe_04 learn1_04 ...
		se_95 pe_95 learn1_95 ...
		assets_95 assets1_95 lassets1_95 assets_95_sq  ...
		fluid episodic exec ...
		O_04 C_04 E_04 A_04 N_04 O_95 C_95 E_95 A_95 N_95 ...
		hs_04 scoll_04 cgrad_04  educ_04 ...
		hs_95 scoll_95 cgrad_95  educ_95 ...
		age_04 age_sq_04 age_95 age_sq_95 ...
		married_04 married_95 num_kids_04 ... 
        sp_educ_04 sp_se_95 sp_pe_95 sp_employ_95 ...
        pointer_latent pointer_beta_w pointer_beta_theta_0 ...
        pointer_e_theta_0 pointer_beta_a_0 pointer_nu_a_0 pointer_e_w_0 ...
        pointer_e_y_0 pointer_nu_y_0 pointer_nu_w_0 pointer_beta_u ... 
        pointer_alpha pointer_lambda ...     
        MODEL0 MODEL1 MODEL2 MODEL3 MODEL4 ... 
        ERRORS_CALC RESULTS DRAWS N N_p CHATTERING RANDU r li lip CFPS;
        

%   EXTRACT ELEMENTS FROM PARAMETER VECTOR

for counterfactuals=0:3

th_ml=theta0;
        
latent      = th_ml(1                     :   pointer_latent)         ;
beta_w      = th_ml(1+pointer_latent      :   pointer_beta_w)         ;     
beta_theta  = th_ml(1+pointer_beta_w      :   pointer_beta_theta_0)   ;
e_theta     = th_ml(1+pointer_beta_theta_0:   pointer_e_theta_0)      ;
beta_a      = th_ml(1+pointer_e_theta_0   :   pointer_beta_a_0)       ;  
nu_a        = th_ml(1+pointer_beta_a_0    :   pointer_nu_a_0)         ;
e_w         = th_ml(1+pointer_nu_a_0      :   pointer_e_w_0)          ;
e_y         = th_ml(1+pointer_e_w_0       :   pointer_e_y_0)          ;
nu_w        = th_ml(1+pointer_e_y_0       :   pointer_nu_w_0)         ;
nu_y        = th_ml(1+pointer_nu_w_0      :   pointer_nu_y_0)         ;
beta_u      = th_ml(1+pointer_nu_y_0      :   pointer_beta_u)         ;
alpha       = th_ml(1+pointer_beta_u      :   pointer_alpha)          ;
lambda      = th_ml(1+pointer_alpha       :   pointer_lambda)         ;   


if counterfactuals==0
    display 'No Change'
elseif counterfactuals==1
    lambda=100                      ;
elseif counterfactuals==2                
    beta_u=zeros(length(beta_u),1)  ;
    beta_u(1,1)=1                   ;
elseif counterfactuals==3
    lambda=100                      ;
    beta_u=zeros(length(beta_u),1)  ;
    beta_u(1,1)=1                   ;
end



if MODEL2~=1
%   MAKE NECESSARY CONVERSIONS

e_theta(3,1)    = abs(e_theta(3,1))     ;  
e_theta(4,1)    = abs(e_theta(4,1))     ;
nu_a            = abs(nu_a)             ;
nu_y            = abs(nu_y)             ;     
nu_w            = abs(nu_w)             ;    
beta_a          = beta_a+1              ;

%   %   CONVERSIONS FOR NO UTILITY

if isempty(beta_u)==1
    beta_u=0;
end

%   %   CONVERSIONS FOR ERROR IN 1995 ASSETS

if isempty(beta_a)==1
    beta_a=1;
end

%   %   MAGNITUDE CONVERSIONS FOR UTILITY

if MODEL0==1
beta_u=beta_u*1000      ;
end

%   %   RHO CONVERSIONS DEPENDING ON MODEL

if MODEL0==1
    rho=1               ;
end

if MODEL1==1 || MODEL2==1 || MODEL3==1 || MODEL4==1
    rho=beta_u(1,1)     ;
end

%   %   CONVERSIONS FOR \LAMBDA AND \ALPHA (ASSUMING NO ERROR CALC)

if ERRORS_CALC==0
    lambda      = 1+exp(lambda-2)                                   ;    
    alpha       = (exp(alpha-2)/(exp(alpha-2)+1))                   ;     
    type_th=exp(e_theta(5,1))/(1+exp(e_theta(5,1)))                 ; 
else
    type_th     = e_theta(5,1)                                      ; 
end

end


















%   LATENT FACTOR STUFF

%   %   To obtain starting values, keep other parameters constant

if MODEL2==1
    
beta_w =    [...
   0.056635082357757
   0.006880213104439
   0.174880341931895
   0.077870415673085
   0.068289554110121
   0.097842614625419
   0.054060738034026
  -0.159642827078511
   0.092028274528880
   8.703598386737813    ];    



beta_theta =    [...
   0.130084737874745
  -0.021618276564982
   0.179897736390001
  -0.187400872318009
  -0.244760926139350
  -0.133106337881180
   0.256638714154588
  -0.327025372280184
   0.023506596357799    ];




e_theta =   [...
   7.036581814827880
  10.046184323934774
   0.952284181950160
   0.192274935913410
   1.343274204689719    ];


beta_a =    [...
   1.010240920721138    ];


nu_a =  [...
   4.607356648093369    ];


e_w =   [...
   0.056251056381024
   0.032083972989566
   0.048209269986871    ];


e_y =   [...
   0.050270958145464
   0.038307719548483
   0.067083327711341    ];


nu_w =  [...
   0.572221307739572    ];


nu_y =  [...
   1.273862197379191    ];


beta_u =    [...
   0.000049814960985
  -0.098981224682278
  -0.035763929048994
   0.193258784625272
  -0.071824134299168
   0.064599896094410
   0.521858977035084
   0.396775981328734
   0.802832984352627
  -0.098713643421447
  -0.196424277639524
  -0.114459293530621
   0.230979273477130
  -2.697414278928461    ];


alpha = [...
   0.143680707292500    ];


lambda =    [...    
   1.938975959782532    ];
    
type_th     =  0.793027867566420      ; 
rho=beta_u(1,1)                 ;
  
end


if MODEL2==1 || MODEL3==1  

latent(6:10,1) = abs(latent(6:10,1))        ;
latent(26:35,1) = abs(latent(26:35,1))      ;

% latent    

MU=latent(1:5,1);
SIGMA=  [...
    latent(6,1)  latent(11,1) latent(12,1) latent(13,1) latent(14,1)    ;
    latent(11,1) latent(7,1)  latent(15,1) latent(16,1) latent(17,1)    ;
    latent(12,1) latent(15,1) latent(8,1)  latent(18,1) latent(19,1)    ;
    latent(13,1) latent(16,1) latent(18,1) latent(9,1)  latent(20,1)    ;
    latent(14,1) latent(17,1) latent(19,1) latent(20,1) latent(10,1)    ;] ;
    
% Check for positive SD

[~,PSD_TEST]=chol(SIGMA);
Norm_SIGMA = norm(SIGMA);

if PSD_TEST==0 && Norm_SIGMA<1.25
rng default
THETA =  mvnrnd(MU,SIGMA,DRAWS*N);  
else
THETA =  10*ones(DRAWS*N,5);  
end    

FO = reshape(THETA(:,1),DRAWS,N);
FC = reshape(THETA(:,2),DRAWS,N);
FE = reshape(THETA(:,3),DRAWS,N);
FA = reshape(THETA(:,4),DRAWS,N);
FN = reshape(THETA(:,5),DRAWS,N);

%%% START, add in x-vars to measurement system
%%% START, add in x-vars to measurement system
%%% START, add in x-vars to measurement system
%%% START, add in x-vars to measurement system

M_O1 = latent(36,1)*age_95+latent(46,1)*educ_95+latent(56,1)*fluid  ;
M_C1 = latent(37,1)*age_95+latent(47,1)*educ_95+latent(57,1)*fluid  ;
M_E1 = latent(38,1)*age_95+latent(48,1)*educ_95+latent(58,1)*fluid  ;
M_A1 = latent(39,1)*age_95+latent(49,1)*educ_95+latent(59,1)*fluid  ;
M_N1 = latent(40,1)*age_95+latent(50,1)*educ_95+latent(60,1)*fluid  ;

M_O2 = latent(41,1)*age_04+latent(51,1)*educ_04+latent(61,1)*fluid  ;
M_C2 = latent(42,1)*age_04+latent(52,1)*educ_04+latent(62,1)*fluid  ;
M_E2 = latent(43,1)*age_04+latent(53,1)*educ_04+latent(63,1)*fluid  ;
M_A2 = latent(44,1)*age_04+latent(54,1)*educ_04+latent(64,1)*fluid  ;
M_N2 = latent(45,1)*age_04+latent(55,1)*educ_04+latent(65,1)*fluid  ;
    
M_O1 = repmat(transpose(M_O1),DRAWS,1);
M_C1 = repmat(transpose(M_C1),DRAWS,1);
M_E1 = repmat(transpose(M_E1),DRAWS,1);
M_A1 = repmat(transpose(M_A1),DRAWS,1);
M_N1 = repmat(transpose(M_N1),DRAWS,1);

M_O2 = repmat(transpose(M_O2),DRAWS,1);
M_C2 = repmat(transpose(M_C2),DRAWS,1);
M_E2 = repmat(transpose(M_E2),DRAWS,1);
M_A2 = repmat(transpose(M_A2),DRAWS,1);
M_N2 = repmat(transpose(M_N2),DRAWS,1);



diff_O1 = repmat(transpose(O_95),DRAWS,1)-FO                -   M_O1    ;                    
diff_O2 = repmat(transpose(O_04),DRAWS,1)-FO*latent(21,1)   -   M_O2    ;                    
diff_C1 = repmat(transpose(C_95),DRAWS,1)-FC                -   M_C1    ;                    
diff_C2 = repmat(transpose(C_04),DRAWS,1)-FC*latent(22,1)   -   M_C2    ;                    
diff_E1 = repmat(transpose(E_95),DRAWS,1)-FE                -   M_E1    ;                    
diff_E2 = repmat(transpose(E_04),DRAWS,1)-FE*latent(23,1)   -   M_E2    ;                    
diff_A1 = repmat(transpose(A_95),DRAWS,1)-FA                -   M_A1    ;                    
diff_A2 = repmat(transpose(A_04),DRAWS,1)-FA*latent(24,1)   -   M_A2    ;                    
diff_N1 = repmat(transpose(N_95),DRAWS,1)-FN                -   M_N1    ;                    
diff_N2 = repmat(transpose(N_04),DRAWS,1)-FN*latent(25,1)   -   M_N2    ;                    

% diff_O1 = repmat(transpose(O_95),DRAWS,1)-FO                    ;                    
% diff_O2 = repmat(transpose(O_04),DRAWS,1)-FO*latent(21,1)       ;                    
% diff_C1 = repmat(transpose(C_95),DRAWS,1)-FC                    ;                    
% diff_C2 = repmat(transpose(C_04),DRAWS,1)-FC*latent(22,1)       ;                    
% diff_E1 = repmat(transpose(E_95),DRAWS,1)-FE                    ;                    
% diff_E2 = repmat(transpose(E_04),DRAWS,1)-FE*latent(23,1)       ;                    
% diff_A1 = repmat(transpose(A_95),DRAWS,1)-FA                    ;                    
% diff_A2 = repmat(transpose(A_04),DRAWS,1)-FA*latent(24,1)       ;                    
% diff_N1 = repmat(transpose(N_95),DRAWS,1)-FN                    ;                    
% diff_N2 = repmat(transpose(N_04),DRAWS,1)-FN*latent(25,1)       ;                    

%%% END, add in x-vars to measurement system
%%% END, add in x-vars to measurement system
%%% END, add in x-vars to measurement system
%%% END, add in x-vars to measurement system

prob_diff_O1 = pdf('norm',diff_O1,0,latent(26,1))               ;
prob_diff_O2 = pdf('norm',diff_O2,0,latent(27,1))               ;

prob_diff_C1 = pdf('norm',diff_C1,0,latent(28,1))               ;
prob_diff_C2 = pdf('norm',diff_C2,0,latent(29,1))               ;

prob_diff_E1 = pdf('norm',diff_E1,0,latent(30,1))               ;
prob_diff_E2 = pdf('norm',diff_E2,0,latent(31,1))               ;

prob_diff_A1 = pdf('norm',diff_A1,0,latent(32,1))               ;
prob_diff_A2 = pdf('norm',diff_A2,0,latent(33,1))               ;

prob_diff_N1 = pdf('norm',diff_N1,0,latent(34,1))               ;
prob_diff_N2 = pdf('norm',diff_N2,0,latent(35,1))               ;

L_O1 = prob_diff_O1                                             ; 
L_O2 = prob_diff_O2                                             ; 
L_C1 = prob_diff_C1                                             ; 
L_C2 = prob_diff_C2                                             ; 
L_E1 = prob_diff_E1                                             ; 
L_E2 = prob_diff_E2                                             ; 
L_A1 = prob_diff_A1                                             ; 
L_A2 = prob_diff_A2                                             ; 
L_N1 = prob_diff_N1                                             ; 
L_N2 = prob_diff_N2                                             ; 

LO = times(L_O1,L_O2)   ;
LC = times(L_C1,L_C2)   ;
LE = times(L_E1,L_E2)   ;
LA = times(L_A1,L_A2)   ;
LN = times(L_N1,L_N2)   ;

LF = times(LO,LE)       ;
LF = times(LF,LC)       ;
LF = times(LF,LA)       ;
L_F = times(LF,LN)      ;

size(L_F)

end








































































%   DISPLAY PARAMETERS

latent       
if MODEL2~=1
beta_w           
beta_theta 
e_theta     
beta_a       
nu_a         
e_w         
e_y         
nu_w        
nu_y        
beta_u       
alpha        
lambda
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%   SOLVE THE MODEL 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%   COMPUTE ERROR ON BUSINESS IDEA [e^theta(g)_i,s] (INCLUDES \mu)

e_theta1 = CHATTERING(:,:,1) * e_theta(3,1) + e_theta(1,1)      ;
e_theta2 = CHATTERING(:,:,2) * e_theta(4,1) + e_theta(2,1)      ;

RANDU1 = RANDU(:,:,1)<type_th                                   ;
RANDU2 = RANDU(:,:,1)>=type_th                                  ;

e_i_theta = times(e_theta1,RANDU1)+times(e_theta2,RANDU2)       ;

%   COMPUTE 2003 ASSETS

e_i_a           = + CHATTERING(:,:,3) * nu_a                    ; 

lassets95_draws = repmat(transpose(lassets1_95),DRAWS,1)        ;

assets95_draws = exp(lassets95_draws)                           ;

lassets1_03     = lassets95_draws*beta_a + e_i_a                ; 

assets1_03      = exp(lassets1_03)                              ;

%   %   COMPUTE Expected[e^w_i | e^\theta_i and A_i] DRAWS

e_i_w = e_w(1,1)*e_i_theta          + ...
        e_w(2,1)*lassets95_draws    + ...
        e_w(3,1)*e_i_a              ;

%   %   COMPUTE Expected[e^y_i | e^\theta_i and A_i] DRAWS

e_i_y = e_y(1,1)*e_i_theta          + ...
        e_y(2,1)*lassets95_draws    + ...
        e_y(3,1)*e_i_a              ;    
        
%   COMPUTE EXPECTED WAGE [PAID EMPLOYMENT]

%   %   FIRST COMPUTE WAGE IN LOGS

if MODEL0==1

lnw_bar =       beta_w(1,1)*educ_04                 + ...
                beta_w(2,1)*age_04                  + ...
                beta_w(3,1)*married_04              + ...        
                beta_w(4,1)*fluid                   + ...
                beta_w(5,1)                         ;   
                                      
elseif MODEL1==1 
    
lnw_bar =       beta_w(1,1)*educ_04                 + ...
                beta_w(2,1)*age_04                  + ...
                beta_w(3,1)*married_04              + ...        
                beta_w(4,1)*fluid                   + ...
                beta_w(5,1)*O_04                    + ...
                beta_w(6,1)*C_04                    + ...        
                beta_w(7,1)*E_04                    + ...
                beta_w(8,1)*A_04                    + ...        
                beta_w(9,1)*N_04                    + ...        
                beta_w(10,1)                        ;   
    
elseif MODEL2==1 || MODEL3==1 || MODEL4==1

lnw_bar =       beta_w(1,1)*educ_04                 + ...
                beta_w(2,1)*age_04                  + ...
                beta_w(3,1)*married_04              + ...        
                beta_w(4,1)*fluid                   + ...
                beta_w(10,1)                        ;   
            
end

%   %   REPEAT TO COMPARE WITH \THETA DRAWS

lnw_bar = transpose(lnw_bar)                        ;

lnw_bar = repmat(lnw_bar,DRAWS,1)                   ; 

%   %   ADD ON THE e_i_w

lnw_bar = lnw_bar+e_i_w                             ; 

if MODEL2==1 || MODEL3==1 || MODEL4==1
  
lnw_bar =       lnw_bar                           + ...     
                beta_w(5,1)*FO                    + ...
                beta_w(6,1)*FC                    + ...        
                beta_w(7,1)*FE                    + ...
                beta_w(8,1)*FA                    + ...        
                beta_w(9,1)*FN                    ;        

end

%   %   COMPUTE EXPONENTIAL

w_bar = exp(lnw_bar)                                ;                      



%   COMPUTE BUSINESS IDEA

%   %   FIRST COMPUTE EXPECTED THETA [theta_bar(g)_i,s]   

if MODEL0==1

ln_theta_bar =  beta_theta(1,1)*lassets1_03         ;

elseif MODEL1==1
    
ln_theta_bar =  beta_theta(1,1)*educ_04             + ...
                beta_theta(2,1)*age_04              + ...
                beta_theta(3,1)*married_04          + ...        
                beta_theta(4,1)*fluid               + ...
                beta_theta(5,1)*O_04                + ...
                beta_theta(6,1)*C_04                + ...        
                beta_theta(7,1)*E_04                + ...
                beta_theta(8,1)*A_04                + ...        
                beta_theta(9,1)*N_04                ;

ln_theta_bar = transpose(ln_theta_bar)              ;
ln_theta_bar = repmat(ln_theta_bar,DRAWS,1)         ; 

elseif MODEL2==1 || MODEL3==1 || MODEL4==1
    
ln_theta_bar =  beta_theta(1,1)*educ_04             + ...
                beta_theta(2,1)*age_04              + ...
                beta_theta(3,1)*married_04          + ...        
                beta_theta(4,1)*fluid               ;

ln_theta_bar = transpose(ln_theta_bar)              ;
ln_theta_bar = repmat(ln_theta_bar,DRAWS,1)         ; 
ln_theta_bar = ln_theta_bar                         + ...
                beta_theta(5,1)*FO                  + ...
                beta_theta(6,1)*FC                  + ...        
                beta_theta(7,1)*FE                  + ...
                beta_theta(8,1)*FA                  + ...        
                beta_theta(9,1)*FN                 ;



end

%   %   COMPUTE THETA BY ADDING EXPECTED THETA TO ERROR 

ln_theta    = ln_theta_bar + e_i_theta              ;

theta       = exp(ln_theta)                         ;

%   COMPUTE UTILITY
     
if MODEL0==1 

utility =  beta_u(1,1);    

elseif MODEL1==1

utility =  beta_u(2,1)*num_kids_04              + ...
           beta_u(3,1)*sp_educ_04               + ...
           beta_u(4,1)*sp_employ_95             + ... 
           beta_u(5,1)*educ_04                  + ...    
           beta_u(6,1)*age_04                   + ...
           beta_u(7,1)*married_04               + ... 
           beta_u(8,1)*fluid                    + ...
           beta_u(9,1)*O_04                     + ...
           beta_u(10,1)*C_04                    + ...
           beta_u(11,1)*E_04                    + ...
           beta_u(12,1)*A_04                    + ...
           beta_u(13,1)*N_04                    + ...
           beta_u(14,1)                         ;

utility = transpose(utility)                    ;
utility = repmat(utility,DRAWS,1)               ; 

elseif MODEL2==1 || MODEL3==1 || MODEL4==1

utility =  beta_u(2,1)*num_kids_04              + ...
           beta_u(3,1)*sp_educ_04               + ...
           beta_u(4,1)*sp_employ_95             + ... 
           beta_u(5,1)*educ_04                  + ...    
           beta_u(6,1)*age_04                   + ...
           beta_u(7,1)*married_04               + ... 
           beta_u(8,1)*fluid                    + ...
           beta_u(14,1)                         ;

utility = transpose(utility)                    ;
utility = repmat(utility,DRAWS,1)               ; 

utility =  utility                              + ...
           beta_u(9,1) *FO                      + ...
           beta_u(10,1)*FC                      + ...
           beta_u(11,1)*FE                      + ...
           beta_u(12,1)*FA                      + ...
           beta_u(13,1)*FN                      ;

meanutil=mean(mean(utility))/beta_u(1,1)        % CHECK

end










%   COMPUTE CONSTRAINT AND EXPECTED EARNINGS IN SELF EMPLOYMENT

%   %   %   COMPUTE CONSTRAINED-INVESTMENT INEQUALITY

r_alpha_lambda  = (power((lambda*assets1_03),(1-alpha)))*(r/(alpha))    ;   

param_psi       = exp(e_i_y)                                            ;
theta_psi       = theta.*exp(e_i_y)                                     ;                  

UNCONSTRAINED_IND   = (theta_psi<=r_alpha_lambda)                       ;                    
CONSTRAINED_IND     = (theta_psi>r_alpha_lambda)                        ;  
  
%   %   %   COMPUTE UNCONSTRAINED EARNINGS [EXPECTED]

k_star  = power((((times(theta,param_psi))*alpha)/r),(1/(1-alpha)))     ; 
y_UNC   = times(param_psi,times(theta,power(k_star,alpha)))             ;

%   %   %   COMPUTE CONSTRAINED EARNINGS [EXPECTED] 

lambda_A = lambda*assets1_03                                            ;         
y_CON = times(param_psi,times(theta,(power(lambda_A,alpha))))           ;

%   %   %   SE UNC. or CON EARNINGS [EXPECTED, WITH AVERAGE DISTURBANCE]

y_UNC_SE          = times(y_UNC,UNCONSTRAINED_IND)                  ;
y_CON_SE          = times(y_CON,CONSTRAINED_IND)                    ;
y_SE              = y_CON_SE+y_UNC_SE                               ;
lny_SE            = log(y_SE)                                       ;  
y_SE_C            = y_SE                                            ;

%   %   COMPUTE PAID VS. SELF EMPLOYMENT CHOICE

%   %   %   UNCONSTRAINED

d_unc = y_SE_C-r*k_star+(utility/rho)-w_bar                         ;              
d_unc_1     = (d_unc>=0)                                            ;

%   %   %   CONSTRAINED

d_con = y_SE_C-r*lambda_A+(utility/rho)-w_bar                       ;              
d_con_1     = (d_con>=0)                                            ;

d_unc_1     = times(d_unc_1, UNCONSTRAINED_IND)                     ;                 
d_con_1     = times(d_con_1, CONSTRAINED_IND)                       ;
d=d_con_1+d_unc_1                                                   ;  


% y_SE_C(1:10,35)
% r*k_star(1:10,35)
% (1/rho)*utility(1:10,35)
% w_bar(1:10,35)
% r*lambda_A(1:10,35)
% d_unc_1(1:10,35)
% d_con_1(1:10,35)
% d(1:10,35)


%   CONSTRUCT LIKELIHOODS FOR EACH INDIVIDUAL / DRAW

diff_w = repmat(transpose(learn1_04),DRAWS,1)-lnw_bar   ;                    
prob_diff_w = pdf('norm',diff_w,-(nu_w^2)/2,nu_w) ;
prob_diff_w_nan=prob_diff_w                             ;
prob_diff_w_nan(d==1)=NaN                               ;
if MODEL0==1 || MODEL1==1  
L_W = transpose(nanmean(prob_diff_w_nan))               ; 
else
L_W = transpose(nanmean(times(prob_diff_w_nan,L_F)))    ; 
end
L_W(isnan(L_W))=0                                       ;

diff_y = repmat(transpose(learn1_04),DRAWS,1)-lny_SE    ; 
prob_diff_y = pdf('norm',diff_y,-(nu_y^2)/2,nu_y) ;
prob_diff_y_nan=prob_diff_y                             ;    
prob_diff_y_nan(d==0)=NaN                               ;    
if MODEL0==1 || MODEL1==1  
L_Y = transpose(nanmean(prob_diff_y_nan))               ; 
else
L_Y = transpose(nanmean(times(prob_diff_y_nan,L_F)))    ; 
end
L_Y(isnan(L_Y))=0                                       ;                                      


P_tilde = mean(d,1)                                     ;   
P_tilde = transpose(P_tilde)                            ;

dd=mean(P_tilde)                                        

if counterfactuals==0
    dd0=dd
end

L_PW    = times(L_W,1-P_tilde)                          ;
L_PY    = times(L_Y,P_tilde)                            ;

L       = times(power(L_PY,se_04),power(L_PW,(1-se_04)));

% if MODEL2==1
% L       = transpose(nanmean(L_F))                       ; 
% end
    
L       = L + ((L==0)*realmin)                          ;
li      = log(L)                                        ;
ll      = -sum(li)                                      ;









%   COUNTERFACTUAL      

clf reset

% set(0,'defaultlinelinewidth',2.0)
% set(0,'defaultaxeslinewidth',2.0)
% set(0,'defaultaxesfontsize',10);
% set(0,'defaulttextfontsize',12);

% set(0,'defaultuicontrolfontname',###); 
% set(0,'defaultuicontrolfontsize',###);
% set(0,'defaultaxesfontname',###); 
% set(0,'defaulttextfontname',###); 

e_w     =   exp(-0.5*nu_w^2+(CHATTERING(:,:,4)*nu_w(1,1)))      ;
w_sim   =   times(w_bar,e_w)                                    ;
w_sim(d==1)=NaN                                                 ;
w_sim   = reshape(w_sim,[],1)                                   ;
w_sim   = w_sim(isnan(w_sim)==0)                                ;
w_sim   = sort(w_sim)                                           ;

e_y     =   exp(-0.5*nu_y^2+(CHATTERING(:,:,5)*nu_y(1,1)))      ;
y_sim   =   times(y_SE,e_y)                                     ;
y_sim(d==0)=NaN                                                 ;
y_sim   = reshape(y_sim,[],1)                                   ;
y_sim   = y_sim(isnan(y_sim)==0)                                ;
y_sim   = sort(y_sim)                                           ;

earnings= exp(learn1_04)                                        ;
w_data  = earnings(pe_04==1)                                    ;    
y_data  = earnings(se_04==1)                                    ;    

lnw_sim = log(w_sim)                                            ;
lny_sim = log(y_sim)                                            ;

lnw_data = log(w_data)                                          ;
lny_data = log(y_data)                                          ;

diff_alll=y_SE-w_bar;
ploop=N*DRAWS                                                   ;
diff_all=reshape(diff_alll,ploop,1)                             ;
diff_SE=diff_all(d==1)                                          ;
diff_PE=diff_all(d==0)                                          ;

if counterfactuals==0   

[f_y,x_y] = ksdensity(y_SE(d==1))                               ;
[f_diff_all,x_diff_all] = ksdensity(diff_all)                   ;
[f_diff_SE,x_diff_SE] = ksdensity(diff_SE)                      ;
[f_diff_PE,x_diff_PE] = ksdensity(diff_PE)                      ;

diff_all_0 = diff_all ;
diff_alll_0 = diff_alll ;
diff_SE_0 = diff_SE ;
diff_PE_0 = diff_PE ;

elseif counterfactuals==1   

[f_y_CC0,x_y_CC0] = ksdensity(y_SE(d==1))                       ;
[f_diff_all_CC0,x_diff_all_CC0] = ksdensity(diff_all)           ;
[f_diff_SE_CC0,x_diff_SE_CC0] = ksdensity(diff_SE)              ;
[f_diff_PE_CC0,x_diff_PE_CC0] = ksdensity(diff_PE)              ;

elseif counterfactuals==2   

[f_y_U0,x_y_U0] = ksdensity(y_SE(d==1))                         ;
[f_diff_all_U0,x_diff_all_U0] = ksdensity(diff_all)             ;
[f_diff_SE_U0,x_diff_SE_U0,bw] = ksdensity(diff_SE)             ;
[f_diff_PE_U0,x_diff_PE_U0] = ksdensity(diff_PE)                ;

elseif counterfactuals==3   

[f_y_BOTH,x_y_BOTH] = ksdensity(y_SE(d==1))                     ;
[f_diff_all_BOTH,x_diff_all_BOTH] = ksdensity(diff_all)         ;
[f_diff_SE_BOTH,x_diff_SE_BOTH,bw] = ksdensity(diff_SE)         ;
[f_diff_PE_BOTH,x_diff_PE_BOTH] = ksdensity(diff_PE)            ;

end

dd=transpose(mean(d))                                           ;
theta_SE=theta(d==1)                                            ;

if counterfactuals==0
    y_sim0=mean(y_sim)                                          ;    
    y_med0=median(y_sim)                                        ;
    thSE0=mean(theta_SE)                                        ;
end

dvec = reshape(d,[2240000,1])                                   ;
size(theta_SE)
size(y_sim)
size(dvec)

sum_theta_SE(counterfactuals+1,1)=mean(dvec)                    ;
sum_theta_SE(counterfactuals+1,2)=(mean(dvec)-dd0)/dd0          ;
sum_theta_SE(counterfactuals+1,3)=mean(y_sim)                   ;
sum_theta_SE(counterfactuals+1,4)=(mean(y_sim)-y_sim0)/y_sim0   ;
sum_theta_SE(counterfactuals+1,5)=median(y_sim)                 ;
sum_theta_SE(counterfactuals+1,6)=(median(y_sim)-y_med0)/y_med0 ;
sum_theta_SE(counterfactuals+1,7)=mean(theta_SE)                ;
sum_theta_SE(counterfactuals+1,8)=(mean(theta_SE)-thSE0)/thSE0  ;

f1SE=O_04       ;
f1PE=O_04       ;
f2SE=C_04       ;
f2PE=C_04       ;
f3SE=E_04       ;
f3PE=E_04       ;
f4SE=A_04       ;
f4PE=A_04       ;
f5SE=N_04       ;
f5PE=N_04       ;

f1SE(d==0)=nan                                              ;
f2SE(d==0)=nan                                              ;
f3SE(d==0)=nan                                              ;
f4SE(d==0)=nan                                              ;
f5SE(d==0)=nan                                              ;

f1PE(d==1)=nan                                              ;
f2PE(d==1)=nan                                              ;
f3PE(d==1)=nan                                              ;
f4PE(d==1)=nan                                              ;
f5PE(d==1)=nan                                              ;

f1SE=transpose(nanmean(f1SE))                               ;
f2SE=transpose(nanmean(f2SE))                               ;
f3SE=transpose(nanmean(f3SE))                               ;
f4SE=transpose(nanmean(f4SE))                               ;
f5SE=transpose(nanmean(f5SE))                               ;

f1PE=transpose(nanmean(f1PE))                               ;
f2PE=transpose(nanmean(f2PE))                               ;
f3PE=transpose(nanmean(f3PE))                               ;
f4PE=transpose(nanmean(f4PE))                               ;
f5PE=transpose(nanmean(f5PE))                               ;


[f_w_data,x_w_data] = ksdensity(w_data)                         ;
[f_y_data,x_y_data] = ksdensity(y_data)                         ;
[f_lnw_data,x_lnw_data] = ksdensity(lnw_data)                   ;
[f_lny_data,x_lny_data] = ksdensity(lny_data)                   ;

[f_w_sim,x_w_sim] = ksdensity(w_sim)                            ;
[f_y_sim,x_y_sim] = ksdensity(y_sim)                            ;
[f_lnw_sim,x_lnw_sim] = ksdensity(lnw_sim)                      ;
[f_lny_sim,x_lny_sim] = ksdensity(lny_sim)                      ;


if counterfactuals==0
[f_theta_SE,x_theta_SE] = ksdensity(theta_SE)                   ;
[f_dd,x_dd] = ksdensity(dd)                                     ;
[f_f1SE,x_f1SE] = ksdensity(f1SE)    ;
[f_f1PE,x_f1PE] = ksdensity(f1PE)    ;
[f_f2SE,x_f2SE] = ksdensity(f2SE)    ;
[f_f2PE,x_f2PE] = ksdensity(f2PE)    ;
[f_f3SE,x_f3SE] = ksdensity(f3SE)    ;
[f_f3PE,x_f3PE] = ksdensity(f3PE)    ;
[f_f4SE,x_f4SE] = ksdensity(f4SE)    ;
[f_f4PE,x_f4PE] = ksdensity(f4PE)    ;
[f_f5SE,x_f5SE] = ksdensity(f5SE)    ;
[f_f5PE,x_f5PE] = ksdensity(f5PE)    ;

elseif counterfactuals==1
[f_theta_SE_CC0,x_theta_SE_CC0] = ksdensity(theta_SE)           ;
[f_dd_CC0,x_dd_CC0] = ksdensity(dd)                             ;
[f_f1SE_CC0,x_f1SE_CC0] = ksdensity(f1SE)    ;
[f_f1PE_CC0,x_f1PE_CC0] = ksdensity(f1PE)    ;
[f_f2SE_CC0,x_f2SE_CC0] = ksdensity(f2SE)    ;
[f_f2PE_CC0,x_f2PE_CC0] = ksdensity(f2PE)    ;
[f_f3SE_CC0,x_f3SE_CC0] = ksdensity(f3SE)    ;
[f_f3PE_CC0,x_f3PE_CC0] = ksdensity(f3PE)    ;
[f_f4SE_CC0,x_f4SE_CC0] = ksdensity(f4SE)    ;
[f_f4PE_CC0,x_f4PE_CC0] = ksdensity(f4PE)    ;
[f_f5SE_CC0,x_f5SE_CC0] = ksdensity(f5SE)    ;
[f_f5PE_CC0,x_f5PE_CC0] = ksdensity(f5PE)    ;

elseif counterfactuals==2
[f_theta_SE_U0,x_theta_SE_U0] = ksdensity(theta_SE)             ;
[f_dd_U0,x_dd_U0] = ksdensity(dd)                               ;
[f_f1SE_U0,x_f1SE_U0] = ksdensity(f1SE)    ;
[f_f1PE_U0,x_f1PE_U0] = ksdensity(f1PE)    ;
[f_f2SE_U0,x_f2SE_U0] = ksdensity(f2SE)    ;
[f_f2PE_U0,x_f2PE_U0] = ksdensity(f2PE)    ;
[f_f3SE_U0,x_f3SE_U0] = ksdensity(f3SE)    ;
[f_f3PE_U0,x_f3PE_U0] = ksdensity(f3PE)    ;
[f_f4SE_U0,x_f4SE_U0] = ksdensity(f4SE)    ;
[f_f4PE_U0,x_f4PE_U0] = ksdensity(f4PE)    ;
[f_f5SE_U0,x_f5SE_U0] = ksdensity(f5SE)    ;
[f_f5PE_U0,x_f5PE_U0] = ksdensity(f5PE)    ;

elseif counterfactuals==3
[f_theta_SE_BOTH,x_theta_SE_BOTH] = ksdensity(theta_SE)         ;
[f_dd_BOTH,x_dd_BOTH] = ksdensity(dd)                           ;
[f_f1SE_BOTH,x_f1SE_BOTH] = ksdensity(f1SE)    ;
[f_f1PE_BOTH,x_f1PE_BOTH] = ksdensity(f1PE)    ;
[f_f2SE_BOTH,x_f2SE_BOTH] = ksdensity(f2SE)    ;
[f_f2PE_BOTH,x_f2PE_BOTH] = ksdensity(f2PE)    ;
[f_f3SE_BOTH,x_f3SE_BOTH] = ksdensity(f3SE)    ;
[f_f3PE_BOTH,x_f3PE_BOTH] = ksdensity(f3PE)    ;
[f_f4SE_BOTH,x_f4SE_BOTH] = ksdensity(f4SE)    ;
[f_f4PE_BOTH,x_f4PE_BOTH] = ksdensity(f4PE)    ;
[f_f5SE_BOTH,x_f5SE_BOTH] = ksdensity(f5SE)    ;
[f_f5PE_BOTH,x_f5PE_BOTH] = ksdensity(f5PE)    ;

end

end

sum_theta_SE

% % % % Plots % % % %
% % % % Plots % % % %
% % % % Plots % % % %

% Navigate to where you want the figures saved
cd ..
cd 'FIGURES/'


thetaBOTH = figure;
hold on
plot(x_theta_SE, f_theta_SE,'k-','Linewidth',1.5)    ;
plot(x_theta_SE_U0, f_theta_SE_U0,'k--','Linewidth',1.5)    ;
plot(x_theta_SE_BOTH, f_theta_SE_BOTH,'k:','Linewidth',2.5)    ;
legend(... 
        '\fontsize{18}Model'  ,...
        '\fontsize{18}No Preferences'  ,... 
        '\fontsize{18}No Preferences & No Constraint') 
xlim([-10000,70000]);
saveas(thetaBOTH,'thetaBOTH.pdf')
hold off


thetaBOTH2 = figure;
hold on
plot(x_theta_SE, f_theta_SE,'k-','Linewidth',1.5)    ;
plot(x_theta_SE_CC0, f_theta_SE_CC0,'k--','Linewidth',1.5)    ;
plot(x_theta_SE_BOTH, f_theta_SE_BOTH,'k:','Linewidth',2.5)    ;
legend(... 
        '\fontsize{18}Model'  ,...
        '\fontsize{18}No Constraint'  ,... 
        '\fontsize{18}No Constraint or Preferences') 
xlim([-10000,70000]);
saveas(thetaBOTH2,'thetaBOTH2.pdf')
hold off

diff0 = figure;
hold on
plot(x_diff_SE, f_diff_SE,'k-','Linewidth',1.5);
plot(x_diff_SE_U0, f_diff_SE_U0,'k--','Linewidth',1.5);
plot(x_diff_SE_BOTH, f_diff_SE_BOTH,'k:','Linewidth',2.5);
legend(... 
        '\fontsize{18}Model',... 
        '\fontsize{18}No Preferences',... 
        '\fontsize{18}No Preferences & No Constraint') 
xlim([-100000,700000]);
saveas(diff0,'diff0.pdf')
hold off

diff1 = figure;
hold on
plot(x_diff_SE, f_diff_SE,'k-','Linewidth',1.5);
plot(x_diff_SE_CC0, f_diff_SE_CC0,'k--','Linewidth',1.5);
legend(... 
        '\fontsize{18}Model',... 
        '\fontsize{18}No Constraint') 
xlim([-100000,850000]);
saveas(diff1,'diff1.pdf')
hold off

diff2 = figure;
hold on
plot(x_diff_SE, f_diff_SE,'k-','Linewidth',1.5);
plot(x_diff_SE_CC0, f_diff_SE_CC0,'k--','Linewidth',1.5);
plot(x_diff_SE_BOTH, f_diff_SE_BOTH,'k:','Linewidth',2.5);
legend(... 
        '\fontsize{18}Model',... 
        '\fontsize{18}No Constraint',...
        '\fontsize{18}No Constraint or Preferences') 
xlim([-100000,600000]);
saveas(diff2,'diff2.pdf')
hold off
 
xlim([-100000,850000]);
saveas(diff2,'diff2.pdf')
hold off

diff_all_sort = sort(diff_all_0);
percentiles=transpose(prctile(diff_all_sort,0:.01:100));
diffALLpercentiles = figure;
scatter(0:.01:100, percentiles,12, 'black')
ylabel( '\fontsize{22}Earnings') 
xlabel( '\fontsize{22}Percentiles') 
horizontal_line(1:length(0:.01:100)) = 0;
hold on
plot(0:.01:100,horizontal_line, 'black')
hold off
ylim([-500000,4500000]);
saveas(diffALLpercentiles,'diffALLpercentiles.pdf')

close all

% Go back to working directory

cd '../SCRIPTS'