%%%%%%                 %%%%%%
% PERSONALITY,              %   
%    CREDIT CONSTRAINTS     %
%       AND SELF-EMPLOYMENT % 
%                           %
%                           %
% L A T E N T F A C T O R S %
%                           %
%                           %
%%%%%%                %%%%%%% 


% Revisions: Permit Correlation.

%   PRELIMINARIES

clear all
clc
cd '~/Dropbox/WORK/Personality/PERSONALITY_FINAL/REPLICATION/2_MATLAB/SCRIPTS/'
format long
    
%   GLOBAL

global  id ...
		se_04 pe_04 learn1_04 ...
		se_95 pe_95 learn1_95 ...
		assets_95 assets1_95 lassets1_95 assets_95_sq assets1_04 lassets1_04 ...
		fluid episodic exec ...
		O_04 C_04 E_04 A_04 N_04 O_95 C_95 E_95 A_95 N_95 ...
		hs_04 scoll_04 cgrad_04  educ_04 ...
		hs_95 scoll_95 cgrad_95  educ_95 ...
		age_04 age_sq_04 age_95 age_sq_95 ...
		married_04 married_95 num_kids_04 ... 
        sp_educ_04 sp_se_95 sp_pe_95 sp_employ_95 ...
        pointer_latent pointer_beta_w pointer_beta_theta_0 ...
        pointer_e_theta_0 pointer_beta_a_0 pointer_nu_a_0 pointer_e_w_0 ...
        pointer_e_y_0 pointer_nu_y_0 pointer_nu_w_0 pointer_beta_u ... 
        pointer_alpha pointer_lambda ...     
        MODEL0 MODEL1 MODEL2 MODEL3 MODEL4 ... 
        ERRORS_CALC RESULTS DRAWS N N_p CHATTERING RANDU r CFPS ;

    
   %   LOAD DATA

load ../DATASETS/personality_ML.csv ;
  
%   SET FIXED VALUES

DRAWS = 2500 ;   
N = length(personality_ML) ; 
r = 1.1 ;

%   CHATTERING

s = RandStream('mcg16807','Seed',0) ;
RandStream.setGlobalStream(s)       ;
CHATTERING = randn(DRAWS,N,11)      ;
RANDU      = rand (DRAWS,N,1)       ;

%   MODEL CHOICE

MODEL0=0;
MODEL1=0;
MODEL2=0;
MODEL3=1;

ERRORS_CALC=0;
TABLES=     0;
CFPS=       1;

%   ASSEMBLE DATA

c=1; 
id                      = personality_ML(:,c);
c=1+c;
se_04                   = personality_ML(:,c);
c=1+c;
pe_04                   = personality_ML(:,c); 
c=1+c;
learn1_04               = personality_ML(:,c);
c=1+c;
se_95                   = personality_ML(:,c); 
c=1+c;
pe_95                   = personality_ML(:,c); 
c=1+c;
learn1_95               = personality_ML(:,c); 
c=1+c;
assets_95               = personality_ML(:,c); 
c=1+c;
assets1_95              = personality_ML(:,c); 
c=1+c;
lassets1_95             = personality_ML(:,c); 
c=1+c;
assets_95_sq            = personality_ML(:,c);
c=1+c;
fluid                   = personality_ML(:,c); 
c=1+c;
episodic                = personality_ML(:,c); 
c=1+c;
exec                    = personality_ML(:,c); 
c=1+c;
A_04                    = personality_ML(:,c); 
c=1+c;
E_04                    = personality_ML(:,c); 
c=1+c;
N_04                    = personality_ML(:,c); 
c=1+c;
C_04                    = personality_ML(:,c); 
c=1+c;
O_04                    = personality_ML(:,c); 
c=1+c;
A_95                    = personality_ML(:,c); 
c=1+c;
E_95                    = personality_ML(:,c); 
c=1+c;
N_95                    = personality_ML(:,c); 
c=1+c;
C_95                    = personality_ML(:,c); 
c=1+c;
O_95                    = personality_ML(:,c);  
c=1+c;
hs_04                   = personality_ML(:,c); 
c=c+1;
scoll_04                = personality_ML(:,c); 
c=1+c;
cgrad_04                = personality_ML(:,c);
c=1+c;
educ_04                 = personality_ML(:,c);
c=1+c;
hs_95                   = personality_ML(:,c); 
c=1+c;
scoll_95                = personality_ML(:,c); 
c=1+c;
cgrad_95                = personality_ML(:,c);
c=1+c;
educ_95                 = personality_ML(:,c);
c=1+c;
age_04                  = personality_ML(:,c); 
c=1+c;
age_sq_04               = personality_ML(:,c);
c=1+c;
age_95                  = personality_ML(:,c); 
c=1+c;
age_sq_95               = personality_ML(:,c);
c=1+c;
married_04              = personality_ML(:,c); 
c=1+c;
married_95              = personality_ML(:,c); 
c=1+c;
num_kids_04             = personality_ML(:,c);
c=1+c;
sp_educ_04              = personality_ML(:,c);
c=1+c;
sp_se_95                = personality_ML(:,c);
c=1+c;
sp_pe_95                = personality_ML(:,c);
c=1+c;
sp_employ_95            = personality_ML(:,c);
c=1+c;
assets1_04              = personality_ML(:,c);
c=1+c;
lassets1_04             = personality_ML(:,c);
c=1+c;

%   STARTING VALUES

% % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % %
% % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % %
% % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % %
% % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % %
% % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % %
% % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % %

if MODEL0==1

% Measurement System Parameters

%   []

% PE Wages - Observables (\beta^w)

beta_w_0(1,1)   = 0.0674935                     ;   % Education
beta_w_0(2,1)   = 0.0041486                     ;   % Age
beta_w_0(3,1)   = 0.2190321                     ;   % Married
beta_w_0(4,1)   = 0.107708                      ;   % Cognition  
beta_w_0(5,1)   = 9.314654                      ;   % Constant

% Business Idea - Observables (\beta^\theta)

%   []

% Business Idea - Error (e_i^\theta)

e_theta_0(1,1)  = 10                            ;   % Constant (Type I)
e_theta_0(2,1)  = 10                            ;   % Constant (Type II)
e_theta_0(3,1)  = 0.75                          ;   % Variance (Type I)   
e_theta_0(4,1)  = 0.75                          ;   % Variance (Type II)
e_theta_0(5,1)  = 2.00                          ;   % Type I Probability

% 2003 Assets - Observables (\beta^a)

beta_a_0(1,1)   = 1                             ;   % Coeff on 1995 Assets                     

% 2003 Assets - Error (\sigma^a)

nu_a_0(1,1)     = 0.1000000                     ;   % Assets var                     

% PE Wage - Error (e_i^w)

e_w_0(1,1)      = 0.1000000                     ;   % e_i^\theta
e_w_0(2,1)      = 0.1000000                     ;   % Assets 1995
e_w_0(3,1)      = 0.1000000                     ;   % e_i^a

% SE Earnings - Error (e_i^w)

e_y_0(1,1)      = 0.1000000                     ;   % e_i^\theta
e_y_0(2,1)      = 0.1000000                     ;   % Assets 1995
e_y_0(3,1)      = 0.1000000                     ;   % e_i^a

% PE Wage Disturbance (\nu^w)

nu_w_0(1,1)     = 0.600000                      ;   % Random Disturbance
    
% PE Wage Disturbance (\nu^w)

nu_y_0(1,1)     = 1.000000                      ;   % Random Disturbance

% Utility

beta_u_0        = 5                             ;   % Utility Dummy

% Additional Structural Parameters

alpha_0         = 0.15                          ;   % Technology

lambda_0        = 2.0                           ;   % Credit constraint
    
theta0= [   beta_w_0 
            e_theta_0
            beta_a_0
            nu_a_0
            e_w_0
            e_y_0
            nu_w_0
            nu_y_0
            beta_u_0
            alpha_0
            lambda_0    ]                       ;   % Full Parameter Vector
            
latent_0=[]                                     ;
beta_theta_0  = []                              ;

N_p     =   length(theta0)                      ;   

% % 100 Draws; SVALS: Initial OLD
% theta0 =   [...  
%    0.054641112911972
%    0.003301406269852
%    0.228798038620911
%    0.146939242509831
%    9.226225932331038
%    7.298551119145383
%    9.346740022656265
%    1.312944866544293
%    1.308055772893531
%    3.515483249625987
%   -0.667215102254879
%    0.169802298988000
%    0.059028074716585
%    0.034418531276698
%    0.273058023868228
%    0.119013780116771
%    0.108833947342200
%    0.094849390179731
%    0.615561343521585
%    1.571542039429394
%    3.894518525214993
%    0.191924324295405
%    1.767625359359990]                   ;

end

% % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % %
% % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % %
% % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % %
% % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % %
% % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % %
% % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % %

if MODEL1==1

% Measurement System Parameters

latent_0        = []                            ;   % Meas. Sys. Param.
        
% PE Wages - Observables (\beta^w)

beta_w_0(1,1)   = 0.0686731                     ;   % Education
beta_w_0(2,1)   = 0.0053884                     ;   % Age
beta_w_0(3,1)   = 0.2032397                     ;   % Married
beta_w_0(4,1)   = 0.1107206                     ;   % Cognition 
beta_w_0(5,1)   = 0.0686038                     ;   % O
beta_w_0(6,1)   = 0.1163253                     ;   % C 
beta_w_0(7,1)   = 0.0620985                     ;   % E 
beta_w_0(8,1)   = -.1764278                     ;   % A 
beta_w_0(9,1)   = 0.0526173                     ;   % N 
beta_w_0(10,1)  = 8.9326210                     ;   % Constant

% Business Idea - Observables (\beta^\theta)

beta_theta_0(1,1)  = 0.1690108                  ;   % Education
beta_theta_0(2,1)  = -.0195551                  ;   % Age
beta_theta_0(3,1)  = 0.1701108                  ;   % Marriage
beta_theta_0(4,1)  = -.1499493                  ;   % Cognition
beta_theta_0(5,1)  = -.2405045                  ;   % O
beta_theta_0(6,1)  = -.1251659                  ;   % C
beta_theta_0(7,1)  = 0.2926286                  ;   % E
beta_theta_0(8,1)  = -.3712079                  ;   % A
beta_theta_0(9,1)  = 0.0234336                  ;   % N


% Business Idea - Error (e_i^\theta)

e_theta_0(1,1)  = 7.000000                      ;   % Constant (Type I)
e_theta_0(2,1)  = 10.00000                      ;   % Constant (Type II)
e_theta_0(3,1)  = 0.50                          ;   % Variance (Type I)   
e_theta_0(4,1)  = 0.25                          ;   % Variance (Type II)
e_theta_0(5,1)  = 2.00                          ;   % Type I Probability

% 2003 Assets - Observables (\beta^a)

beta_a_0(1,1)   = 0.050                         ;   % Coeff on 1995 Assets                     

% 2003 Assets - Error (\sigma^a)

nu_a_0(1,1)     = 3.800000                     ;   % Assets var                     

% PE Wage - Error (e_i^w)

e_w_0(1,1)      = 0.0500000                     ;   % e_i^\theta
e_w_0(2,1)      = 0.0500000                     ;   % Assets 1995
e_w_0(3,1)      = 0.0500000                     ;   % e_i^a

% SE Earnings - Error (e_i^w)

e_y_0(1,1)      = 0.0500000                     ;   % e_i^\theta
e_y_0(2,1)      = 0.0500000                     ;   % Assets 1995
e_y_0(3,1)      = 0.0500000                     ;   % e_i^a

% PE Wage Disturbance (\nu^w)

nu_w_0(1,1)     = 0.600000                      ;   % Random Disturbance
    
% PE Wage Disturbance (\nu^w)

nu_y_0(1,1)     = 1.0000000                     ;   % Random Disturbance

% Utility SVALS

beta_u_0(1,1)   =   0.0000500                   ;   % Weight
beta_u_0(2,1)   =   -.0735519                   ;   % Number of Kids
beta_u_0(3,1)   =   -.0355772                   ;   % Spouse Education
beta_u_0(4,1)   =   0.1810937                   ;   % Spouse Employment
beta_u_0(5,1)   =   -.1082053                   ;   % Education
beta_u_0(6,1)   =   0.0604791                   ;   % Age
beta_u_0(7,1)   =   0.6346620                   ;   % Married
beta_u_0(8,1)   =   0.2528205                   ;   % Cognition
beta_u_0(9,1)   =   0.6740048                   ;   % O
beta_u_0(10,1)  =   -.0897720                   ;   % C
beta_u_0(11,1)  =   -.1746481                   ;   % E
beta_u_0(12,1)  =   -.1751071                   ;   % A
beta_u_0(13,1)  =   0.2637548                   ;   % N
beta_u_0(14,1)  =   -3.541510                   ;   % Constant

% Additional Structural Parameters

alpha_0         = 0.25                          ;   % Technology

lambda_0        = 2.0                           ;   % Credit constraint
    
theta0= [   beta_w_0 
            beta_theta_0
            e_theta_0
            beta_a_0
            nu_a_0
            e_w_0
            e_y_0
            nu_w_0
            nu_y_0
            beta_u_0
            alpha_0
            lambda_0    ]                       ;   % Full Parameter Vector
            
N_p     =   length(theta0)                      ;  

% 2500 Draws; SVALS as above
theta0=[
   0.056635082357757
   0.006880213104439
   0.174880341931895
   0.077870415673085
   0.068289554110121
   0.097842614625419
   0.054060738034026
  -0.159642827078511
   0.092028274528880
   8.703598386737813
   0.130084737874745
  -0.021618276564982
   0.179897736390001
  -0.187400872318009
  -0.244760926139350
  -0.133106337881180
   0.256638714154588
  -0.327025372280184
   0.023506596357799
   7.036581814827880
  10.046184323934774
   0.952284181950160
   0.192274935913410
   1.343274204689719
   0.010240920721138
   4.607356648093369
   0.056251056381024
   0.032083972989566
   0.048209269986871
   0.050270958145464
   0.038307719548483
   0.067083327711341
   0.572221307739572
   1.273862197379191
   0.000049814960985
  -0.098981224682278
  -0.035763929048994
   0.193258784625272
  -0.071824134299168
   0.064599896094410
   0.521858977035084
   0.396775981328734
   0.802832984352627
  -0.098713643421447
  -0.196424277639524
  -0.114459293530621
   0.230979273477130
  -2.697414278928461
   0.214950215142661
   1.937034597962855]        ;

end


% % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % %
% % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % %
% % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % %
% % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % %
% % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % %
% % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % %

if MODEL2==1

% Measurement System Parameters

latent_0(1,1)   = 3.50                          ;   % Mean \theta_O
latent_0(2,1)   = 2.75                          ;   % Mean \theta_C
latent_0(3,1)   = 2.50                          ;   % Mean \theta_E
latent_0(4,1)   = 3.75                          ;   % Mean \theta_A
latent_0(5,1)   = 3.50                          ;   % Mean \theta_N

latent_0(6,1)   = 0.50                          ;   % Var OO (1,1)
latent_0(7,1)   = 0.50                          ;   % Var CC (2,2)
latent_0(8,1)   = 0.50                          ;   % Var EE (3,3)
latent_0(9,1)   = 0.50                          ;   % Var AA (4,4)
latent_0(10,1)  = 0.50                          ;   % Var NN (5,5)
latent_0(11,1)  = 0.10                          ;   % Var OC (1,2)
latent_0(12,1)  = 0.10                          ;   % Var CE (1,3)
latent_0(13,1)  = 0.10                          ;   % Var EA (1,4)
latent_0(14,1)  = 0.10                          ;   % Var AN (1,5)
latent_0(15,1)  = 0.10                          ;   % Var CE (2,3)
latent_0(16,1)  = 0.10                          ;   % Var CA (2,4)
latent_0(17,1)  = 0.10                          ;   % Var CN (2,5)
latent_0(18,1)  = 0.10                          ;   % Var EA (3,4)
latent_0(19,1)  = 0.10                          ;   % Var EN (3,5)
latent_0(20,1)  = 0.10                          ;   % Var AN (4,5)

latent_0(21,1)  = 1.00                          ;   % FL_O
latent_0(22,1)  = 1.00                          ;   % FL_C
latent_0(23,1)  = 1.00                          ;   % FL_E
latent_0(24,1)  = 1.00                          ;   % FL_A
latent_0(25,1)  = 1.00                          ;   % FL_N

latent_0(26,1)  = 0.50                          ;   % e^O_1
latent_0(27,1)  = 0.50                          ;   % e^C_1
latent_0(28,1)  = 0.50                          ;   % e^E_1
latent_0(29,1)  = 0.50                          ;   % e^A_1
latent_0(30,1)  = 0.50                          ;   % e^N_1

latent_0(31,1)  = 0.50                          ;   % e^O_2
latent_0(32,1)  = 0.50                          ;   % e^C_2
latent_0(33,1)  = 0.50                          ;   % e^E_2
latent_0(34,1)  = 0.50                          ;   % e^A_2
latent_0(35,1)  = 0.50                          ;   % e^N_2

latent_0(36,1)  = -.02                          ;   % AGE_95_O
latent_0(37,1)  = -.02                          ;   % AGE_95_C
latent_0(38,1)  = -.02                          ;   % AGE_95_E
latent_0(39,1)  = -.02                          ;   % AGE_95_A
latent_0(40,1)  = -.02                          ;   % AGE_95_N

latent_0(41,1)  = -.02                          ;   % AGE_04_O
latent_0(42,1)  = -.02                          ;   % AGE_04_C
latent_0(43,1)  = -.02                          ;   % AGE_04_E
latent_0(44,1)  = -.02                          ;   % AGE_04_A
latent_0(45,1)  = -.02                          ;   % AGE_04_N

latent_0(46,1)  = 0.01                          ;   % EDUC_95_O
latent_0(47,1)  = 0.01                          ;   % EDUC_95_C
latent_0(48,1)  = 0.01                          ;   % EDUC_95_E
latent_0(49,1)  = 0.01                          ;   % EDUC_95_A
latent_0(50,1)  = 0.01                          ;   % EDUC_95_N

latent_0(51,1)  = 0.01                          ;   % EDUC_04_O
latent_0(52,1)  = 0.01                          ;   % EDUC_04_C
latent_0(53,1)  = 0.01                          ;   % EDUC_04_E
latent_0(54,1)  = 0.01                          ;   % EDUC_04_A
latent_0(55,1)  = 0.01                          ;   % EDUC_04_N

latent_0(56,1)  = 0.01                          ;   % COG_95_O
latent_0(57,1)  = 0.01                          ;   % COG_95_C
latent_0(58,1)  = 0.01                          ;   % COG_95_E
latent_0(59,1)  = 0.01                          ;   % COG_95_A
latent_0(60,1)  = 0.01                          ;   % COG_95_N

latent_0(61,1)  = 0.01                          ;   % COG_04_O
latent_0(62,1)  = 0.01                          ;   % COG_04_C
latent_0(63,1)  = 0.01                          ;   % COG_04_E
latent_0(64,1)  = 0.01                          ;   % COG_04_A
latent_0(65,1)  = 0.01                          ;   % COG_04_N

% Keep All Other Parameters Constant

beta_w_0        = []                            ;
beta_theta_0    = []                            ;
e_theta_0       = []                            ;
beta_a_0        = []                            ;
nu_a_0          = []                            ;
e_w_0           = []                            ;
e_y_0           = []                            ;
nu_w_0          = []                            ;
nu_y_0          = []                            ;
beta_u_0        = []                            ;
alpha_0         = []                            ;
lambda_0        = []                            ;

    
theta0= [   latent_0
            beta_w_0 
            beta_theta_0
            e_theta_0
            beta_a_0
            nu_a_0
            e_w_0
            e_y_0
            nu_w_0
            nu_y_0
            beta_u_0
            alpha_0
            lambda_0    ]                       ;   % Full Parameter Vector
            
N_p     =   length(theta0)                      ;  

% 2500 Draws; SVALS from above; Fixing Main Estimates from MODEL1

theta0=[
   3.591507239042013
   3.790269161528067
   3.843804138307281
   4.000336253296026
   2.970945860017145
   0.181338253797923
   0.123854528392114
   0.262238358599892
   0.238504118223082
   0.261025926930079
   0.051259205353204
   0.145757170452181
   0.130298688306354
  -0.058227650060179
   0.059286804090013
   0.060661727457928
  -0.040338516237575
   0.162734203641200
  -0.057033820960393
  -0.017203826042163
   0.922782394229372
   0.990605802833042
   0.952968126032296
   0.896972866790893
   0.927187509056519
   0.268580105256724
   0.327663173889767
   0.271286891564027
   0.273302247164998
   0.288143392201295
   0.338465608819410
   0.302096289567172
   0.342234404256688
   0.413228423085433
   0.396236982099360
  -0.011626971570793
  -0.002471018351420
  -0.008998926968702
  -0.007360927666022
  -0.006975811004692
  -0.006650095335299
  -0.001175203529560
  -0.001967674404543
  -0.000304603198179
  -0.005939348299135
  -0.002035078562126
  -0.018249333313365
  -0.020808663890363
  -0.025751562015399
  -0.034944069239712
  -0.000295279339323
  -0.014078155143978
  -0.033511400591047
  -0.020707632354321
  -0.028598637212583
   0.052116784380932
   0.007634799302094
   0.021336948846016
   0.018919994456361
   0.004070340910181
   0.065486172509072
  -0.027911552594591
   0.032200104031800
   0.025784086448335
  -0.019624202835958];

end

% % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % %
% % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % %
% % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % %
% % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % %
% % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % %
% % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % %

if MODEL3==1

% Measurement System Parameters

latent_0(1,1)   = 3.50                          ;   % Mean \theta_O
latent_0(2,1)   = 2.75                          ;   % Mean \theta_C
latent_0(3,1)   = 2.50                          ;   % Mean \theta_E
latent_0(4,1)   = 3.75                          ;   % Mean \theta_A
latent_0(5,1)   = 3.50                          ;   % Mean \theta_N

latent_0(6,1)   = 0.50                          ;   % Var OO  
latent_0(7,1)   = 0.50                          ;   % Var CC  
latent_0(8,1)   = 0.50                          ;   % Var EE  
latent_0(9,1)   = 0.50                          ;   % Var AA  
latent_0(10,1)  = 0.50                          ;   % Var NN  
latent_0(11,1)  = 0.10                          ;   % Var OC  
latent_0(12,1)  = 0.10                          ;   % Var OE  
latent_0(13,1)  = 0.10                          ;   % Var OA  
latent_0(14,1)  = 0.10                          ;   % Var ON 
latent_0(15,1)  = 0.10                          ;   % Var CE 
latent_0(16,1)  = 0.10                          ;   % Var CA 
latent_0(17,1)  = 0.10                          ;   % Var CN 
latent_0(18,1)  = 0.10                          ;   % Var EA 
latent_0(19,1)  = 0.10                          ;   % Var EN 
latent_0(20,1)  = 0.10                          ;   % Var AN 

latent_0(21,1)  = 1.00                          ;   % FL_O
latent_0(22,1)  = 1.00                          ;   % FL_C
latent_0(23,1)  = 1.00                          ;   % FL_E
latent_0(24,1)  = 1.00                          ;   % FL_A
latent_0(25,1)  = 1.00                          ;   % FL_N

latent_0(26,1)  = 0.50                          ;   % e^O_1
latent_0(27,1)  = 0.50                          ;   % e^C_1
latent_0(28,1)  = 0.50                          ;   % e^E_1
latent_0(29,1)  = 0.50                          ;   % e^A_1
latent_0(30,1)  = 0.50                          ;   % e^N_1

latent_0(31,1)  = 0.50                          ;   % e^O_2
latent_0(32,1)  = 0.50                          ;   % e^C_2
latent_0(33,1)  = 0.50                          ;   % e^E_2
latent_0(34,1)  = 0.50                          ;   % e^A_2
latent_0(35,1)  = 0.50                          ;   % e^N_2

latent_0(36,1)  = -.02                          ;   % AGE_95_O
latent_0(37,1)  = -.02                          ;   % AGE_95_C
latent_0(38,1)  = -.02                          ;   % AGE_95_E
latent_0(39,1)  = -.02                          ;   % AGE_95_A
latent_0(40,1)  = -.02                          ;   % AGE_95_N

latent_0(41,1)  = -.02                          ;   % AGE_04_O
latent_0(42,1)  = -.02                          ;   % AGE_04_C
latent_0(43,1)  = -.02                          ;   % AGE_04_E
latent_0(44,1)  = -.02                          ;   % AGE_04_A
latent_0(45,1)  = -.02                          ;   % AGE_04_N

latent_0(46,1)  = 0.01                          ;   % EDUC_95_O
latent_0(47,1)  = 0.01                          ;   % EDUC_95_C
latent_0(48,1)  = 0.01                          ;   % EDUC_95_E
latent_0(49,1)  = 0.01                          ;   % EDUC_95_A
latent_0(50,1)  = 0.01                          ;   % EDUC_95_N

latent_0(51,1)  = 0.01                          ;   % EDUC_04_O
latent_0(52,1)  = 0.01                          ;   % EDUC_04_C
latent_0(53,1)  = 0.01                          ;   % EDUC_04_E
latent_0(54,1)  = 0.01                          ;   % EDUC_04_A
latent_0(55,1)  = 0.01                          ;   % EDUC_04_N

latent_0(56,1)  = 0.01                          ;   % COG_95_O
latent_0(57,1)  = 0.01                          ;   % COG_95_C
latent_0(58,1)  = 0.01                          ;   % COG_95_E
latent_0(59,1)  = 0.01                          ;   % COG_95_A
latent_0(60,1)  = 0.01                          ;   % COG_95_N

latent_0(61,1)  = 0.01                          ;   % COG_04_O
latent_0(62,1)  = 0.01                          ;   % COG_04_C
latent_0(63,1)  = 0.01                          ;   % COG_04_E
latent_0(64,1)  = 0.01                          ;   % COG_04_A
latent_0(65,1)  = 0.01                          ;   % COG_04_N

        
% PE Wages - Observables (\beta^w)

beta_w_0(1,1)   = 0.0686731                     ;   % Education
beta_w_0(2,1)   = 0.0053884                     ;   % Age
beta_w_0(3,1)   = 0.2032397                     ;   % Married
beta_w_0(4,1)   = 0.1107206                     ;   % Cognition 
beta_w_0(5,1)   = 0.0686038                     ;   % O
beta_w_0(6,1)   = 0.1163253                     ;   % C 
beta_w_0(7,1)   = 0.0620985                     ;   % E 
beta_w_0(8,1)   = -.1764278                     ;   % A 
beta_w_0(9,1)   = 0.0526173                     ;   % N 
beta_w_0(10,1)  = 8.9326210                     ;   % Constant

% Business Idea - Observables (\beta^\theta)

beta_theta_0(1,1)  = 0.1690108                  ;   % Education
beta_theta_0(2,1)  = -.0195551                  ;   % Age
beta_theta_0(3,1)  = 0.1701108                  ;   % Marriage
beta_theta_0(4,1)  = -.1499493                  ;   % Cognition
beta_theta_0(5,1)  = -.2405045                  ;   % O
beta_theta_0(6,1)  = -.1251659                  ;   % C
beta_theta_0(7,1)  = 0.2926286                  ;   % E
beta_theta_0(8,1)  = -.3712079                  ;   % A
beta_theta_0(9,1) = 0.0234336                  ;   % N


% Business Idea - Error (e_i^\theta)

e_theta_0(1,1)  = 7.000000                      ;   % Constant (Type I)
e_theta_0(2,1)  = 10.00000                      ;   % Constant (Type II)
e_theta_0(3,1)  = 0.50                          ;   % Variance (Type I)   
e_theta_0(4,1)  = 0.25                          ;   % Variance (Type II)
e_theta_0(5,1)  = 2.00                          ;   % Type I Probability

% 2003 Assets - Observables (\beta^a)

beta_a_0(1,1)   = 0.050                         ;   % Coeff on 1995 Assets                     

% 2003 Assets - Error (\sigma^a)

nu_a_0(1,1)     = 3.800000                     ;   % Assets var                     

% PE Wage - Error (e_i^w)

e_w_0(1,1)      = 0.0500000                     ;   % e_i^\theta
e_w_0(2,1)      = 0.0500000                     ;   % Assets 1995
e_w_0(3,1)      = 0.0500000                     ;   % e_i^a

% SE Earnings - Error (e_i^w)

e_y_0(1,1)      = 0.0500000                     ;   % e_i^\theta
e_y_0(2,1)      = 0.0500000                     ;   % Assets 1995
e_y_0(3,1)      = 0.0500000                     ;   % e_i^a

% PE Wage Disturbance (\nu^w)

nu_w_0(1,1)     = 0.600000                      ;   % Random Disturbance
    
% PE Wage Disturbance (\nu^w)

nu_y_0(1,1)     = 1.0000000                     ;   % Random Disturbance

% Utility SVALS

beta_u_0(1,1)   =   0.0000500                   ;   % Weight
beta_u_0(2,1)   =   -.0735519                   ;   % Number of Kids
beta_u_0(3,1)   =   -.0355772                   ;   % Spouse Education
beta_u_0(4,1)   =   0.1810937                   ;   % Spouse Employment
beta_u_0(5,1)   =   -.1082053                   ;   % Education
beta_u_0(6,1)   =   0.0604791                   ;   % Age
beta_u_0(7,1)   =   0.6346620                   ;   % Married
beta_u_0(8,1)   =   0.2528205                   ;   % Cognition
beta_u_0(9,1)   =   0.6740048                   ;   % O
beta_u_0(10,1)  =   -.0897720                   ;   % C
beta_u_0(11,1)  =   -.1746481                   ;   % E
beta_u_0(12,1)  =   -.1751071                   ;   % A
beta_u_0(13,1)  =   0.2637548                   ;   % N
beta_u_0(14,1)  =   -3.541510                   ;   % Constant

% Additional Structural Parameters

alpha_0         = 0.25                          ;   % Technology

lambda_0        = 2.0                           ;   % Credit constraint
    
theta0= [   latent_0
            beta_w_0 
            beta_theta_0
            e_theta_0
            beta_a_0
            nu_a_0
            e_w_0
            e_y_0
            nu_w_0
            nu_y_0
            beta_u_0
            alpha_0
            lambda_0    ]                       ;   % Full Parameter Vector
                        
N_p     =   length(theta0)                      ;  

%Starting Values from MODEL1 and MODEL2
theta0= [ ... 
   3.591507239042013
   3.790269161528067
   3.843804138307281
   4.000336253296026
   2.970945860017145
   0.181338253797923
   0.123854528392114
   0.262238358599892
   0.238504118223082
   0.261025926930079
   0.051259205353204
   0.145757170452181
   0.130298688306354
  -0.058227650060179
   0.059286804090013
   0.060661727457928
  -0.040338516237575
   0.162734203641200
  -0.057033820960393
  -0.017203826042163
   0.922782394229372
   0.990605802833042
   0.952968126032296
   0.896972866790893
   0.927187509056519
   0.268580105256724
   0.327663173889767
   0.271286891564027
   0.273302247164998
   0.288143392201295
   0.338465608819410
   0.302096289567172
   0.342234404256688
   0.413228423085433
   0.396236982099360
  -0.011626971570793
  -0.002471018351420
  -0.008998926968702
  -0.007360927666022
  -0.006975811004692
  -0.006650095335299
  -0.001175203529560
  -0.001967674404543
  -0.000304603198179
  -0.005939348299135
  -0.002035078562126
  -0.018249333313365
  -0.020808663890363
  -0.025751562015399
  -0.034944069239712
  -0.000295279339323
  -0.014078155143978
  -0.033511400591047
  -0.020707632354321
  -0.028598637212583
   0.052116784380932
   0.007634799302094
   0.021336948846016
   0.018919994456361
   0.004070340910181
   0.065486172509072
  -0.027911552594591
   0.032200104031800
   0.025784086448335
  -0.019624202835958
   0.056635082357757 % This is where non latent parameters start
   0.006880213104439
   0.174880341931895
   0.077870415673085
   0.068289554110121
   0.097842614625419
   0.054060738034026
  -0.159642827078511
   0.092028274528880
   8.703598386737813
   0.130084737874745
  -0.021618276564982
   0.179897736390001
  -0.187400872318009
  -0.244760926139350
  -0.133106337881180
   0.256638714154588
  -0.327025372280184
   0.023506596357799
   7.036581814827880
  10.046184323934774
   0.952284181950160
   0.192274935913410
   1.343274204689719
   0.010240920721138
   4.607356648093369
   0.056251056381024
   0.032083972989566
   0.048209269986871
   0.050270958145464
   0.038307719548483
   0.067083327711341
   0.572221307739572
   1.273862197379191
   0.000049814960985
  -0.098981224682278
  -0.035763929048994
   0.193258784625272
  -0.071824134299168
   0.064599896094410
   0.521858977035084
   0.396775981328734
   0.802832984352627
  -0.098713643421447
  -0.196424277639524
  -0.114459293530621
   0.230979273477130
  -2.697414278928461
   0.214950215142661
   1.937034597962855        ]   ;


theta0= [ ... 
   3.580444855142484
   3.780050138037685
   3.840719686857980
   3.995264012439977
   2.969021825060862
   0.182979401044257
   0.124322645732791
   0.265179392147916
   0.238406752014652
   0.260424895402937
   0.051541624004522
   0.145193496627093
   0.129750849329404
  -0.058421835021433
   0.059267748264780
   0.060394940128210
  -0.040509517729193
   0.163695880565503
  -0.057211434478259
  -0.017226119908988
   0.922457187648320
   0.991041696087572
   0.953529626596374
   0.897020594033608
   0.928627549132856
   0.266887482550068
   0.327805679495773
   0.270392167237093
   0.275398210196033
   0.287538501752581
   0.340857513848212
   0.302314130809437
   0.344718139204930
   0.411711770368820
   0.397010741802809
  -0.011615388804954
  -0.002468328011068
  -0.009062093626329
  -0.007358217861217
  -0.006972993943610
  -0.006648506866860
  -0.001182056672682
  -0.001983310816861
  -0.000306602548880
  -0.005961723279230
  -0.002045141028701
  -0.018267822534863
  -0.020762707881985
  -0.026144396356643
  -0.035023177691576
  -0.000296646026415
  -0.014123079905469
  -0.033753377959814
  -0.020852493058210
  -0.028712703083145
   0.052255370995097
   0.007679410889846
   0.021454327649088
   0.018946515443084
   0.004093679964451
   0.065738526384399
  -0.028147356301027
   0.032381781428292
   0.025929669808948
  -0.019690398078493
   0.055733846653704
   0.006882888720922
   0.175737605020883
   0.078249570003788
   0.066843509625253
   0.097554846869077
   0.054205743330059
  -0.161597929557816
   0.091896228159129
   8.678375393508654
   0.130534068076230
  -0.021460338088212
   0.180843190129350
  -0.187225831294959
  -0.244414240853193
  -0.133377468269388
   0.257595288427061
  -0.322681594369065
   0.023569985997072
   6.668115387827699
  10.167146671064117
   0.942506394285338
   0.189702447849091
   1.340067409841664
   0.010260041465653
   4.602346896784026
   0.056082933125358
   0.031688703616396
   0.048405910610544
   0.050431670269681
   0.038297647729475
   0.067547226707245
   0.579294335170723
   1.253739912931943
   0.000048419692933
  -0.100630226657393
  -0.036017161891764
   0.194211543996665
  -0.072424801813183
   0.063913232883391
   0.512542397967017
   0.411569261798605
   0.793739677357102
  -0.099205018911589
  -0.198156091491979
  -0.115664131528869
   0.228519039263920
  -2.723687674686504
   0.215325176501941
   1.938544959856566];

end





















% % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % %
% % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % %
% % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % %
% % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % %
% % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % %
% % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % %

%   POINTERS

pointer_latent      = length(latent_0)                              ;
pointer_beta_w      = pointer_latent      + length(beta_w_0)        ;
pointer_beta_theta_0= pointer_beta_w      + length(beta_theta_0)    ;
pointer_e_theta_0   = pointer_beta_theta_0+ length(e_theta_0)       ;
pointer_beta_a_0    = pointer_e_theta_0   + length(beta_a_0)        ;  
pointer_nu_a_0      = pointer_beta_a_0    + length(nu_a_0)          ;
pointer_e_w_0       = pointer_nu_a_0      + length(e_w_0)           ;
pointer_e_y_0       = pointer_e_w_0       + length(e_y_0)           ;
pointer_nu_w_0      = pointer_e_y_0       + length(nu_w_0)          ;
pointer_nu_y_0      = pointer_nu_w_0      + length(nu_y_0)          ;
pointer_beta_u      = pointer_nu_y_0      + length(beta_u_0)        ;
pointer_alpha       = pointer_beta_u      + length(alpha_0)         ;
pointer_lambda      = pointer_alpha       + length(lambda_0)        ;

%   EVALUATE LIKELIHOOD

ll      =   LL(theta0)

%   OPTIMIZATION

if ERRORS_CALC==0 && CFPS==0 && (MODEL1==0 || MODEL1==1 || MODEL2==1)

display 'BEGIN: Optimization Routine'

options     = optimset('MaxIter',10000000,'MaxFunEvals',20000000,'Display', [],'Tolfun', 1e-2, 'TolX', 1e-2, 'PlotFcns', @optimplotfval);

theta_ml    = fminsearch(@LL,theta0,options);

theta0      = theta_ml ;

options     = optimset('MaxIter',10000000,'MaxFunEvals',20000000,'Display', [],'Tolfun', 1e-10, 'TolX', 1e-10, 'PlotFcns', @optimplotfval);

theta_ml    = fmincon(@LL,theta0,[],[],[],[],-inf*ones(length(theta0),1),inf*ones(length(theta0),1),[],options);

theta0      = theta_ml ;

options     = optimset('MaxIter',10000,'MaxFunEvals',10000,'Display', [],'Tolfun', 1e-10, 'TolX', 1e-10, 'PlotFcns', @optimplotfval);

theta_ml    = fminunc(@LL,theta0,options);

options     = optimset('MaxIter',10000000,'MaxFunEvals',20000000,'Display', [],'Tolfun', 1e-2, 'TolX', 1e-2, 'PlotFcns', @optimplotfval);

theta_ml    = fminsearch(@LL,theta0,options);

theta0      = theta_ml ;

options     = optimset('MaxIter',10000000,'MaxFunEvals',20000000,'Display', [],'Tolfun', 1e-10, 'TolX', 1e-10, 'PlotFcns', @optimplotfval);

theta_ml    = fmincon(@LL,theta0,[],[],[],[],-inf*ones(length(theta0),1),inf*ones(length(theta0),1),[],options);

theta0      = theta_ml ;

options     = optimset('MaxIter',10000,'MaxFunEvals',10000,'Display', [],'Tolfun', 1e-10, 'TolX', 1e-10, 'PlotFcns', @optimplotfval);

theta_ml    = fminunc(@LL,theta0,options);

end    

% % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % %
% % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % %
% % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % %
% % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % %
% % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % %
% % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % %

% STANDARD ERRORS

if ERRORS_CALC==1

theta_ml_R=theta0

if MODEL0==1
    type_th_R   = theta_ml_R(10,1)                      ;       
    alpha_R     = theta_ml_R(22,1)                      ;      
    lambda_R    = theta_ml_R(23,1)                      ;
    
    theta_ml_R(10,1)    = exp(type_th_R)/(1+exp(type_th_R))         ; 
    theta_ml_R(22,1)    = (exp(alpha_R-2)/(exp(alpha_R-2)+1))       ;     
    theta_ml_R(23,1)    = 1+exp(lambda_R-2)                         ;    
end    
    
if MODEL1==1
    type_th_R   = theta_ml_R(24,1)                      ;       
    alpha_R     = theta_ml_R(49,1)                      ;      
    lambda_R    = theta_ml_R(50,1)                      ;
    
    theta_ml_R(24,1)    = exp(type_th_R)/(1+exp(type_th_R))         ; 
    theta_ml_R(49,1)    = (exp(alpha_R-2)/(exp(alpha_R-2)+1))       ;     
    theta_ml_R(50,1)    = 1+exp(lambda_R-2)                         ;    
end    

if MODEL2==1
    type_th_R   = theta_ml_R(24,1)                      ;       
    alpha_R     = theta_ml_R(49,1)                      ;      
    lambda_R    = theta_ml_R(50,1)                      ;
    
    theta_ml_R(24,1)    = exp(type_th_R)/(1+exp(type_th_R))         ; 
    theta_ml_R(49,1)    = (exp(alpha_R-2)/(exp(alpha_R-2)+1))       ;     
    theta_ml_R(50,1)    = 1+exp(lambda_R-2)                         ;    
end    

if MODEL3==1
    type_th_R   = theta_ml_R(89,1)                       ;       
    beta_a      = theta_ml_R(90,1)                       ;       
    alpha_R     = theta_ml_R(114,1)                      ;      
    lambda_R    = theta_ml_R(115,1)                      ;
    
    theta_ml_R(89,1)     = exp(type_th_R)/(1+exp(type_th_R))         ; 
    theta_ml_R(90,1)    =  theta_ml_R(90,1)+1                        ;     
    theta_ml_R(114,1)    = (exp(alpha_R-2)/(exp(alpha_R-2)+1))       ;     
    theta_ml_R(115,1)    = 1+exp(lambda_R-2)                         ;    
end    

ll      =   LL(theta_ml_R)

st_error=ERRORS(theta_ml_R); 
    
format shortg  
RESULTS = [theta_ml_R st_error] 
RESULTS = round(RESULTS*1000)/1000










% GENERATE TABLES

if TABLES==1 && MODEL3==1
    run tablelatentfactors
    run tablelatentfactors2
end

end